#! /usr/bin/env lua

--[[
	This file is part of NeuralView.

    NeuralView is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NeuralView is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NeuralView.  If not, see <http://www.gnu.org/licenses/>.
--]]

---
-- Main application.

-- ** Global definitions **

---
-- module definition
function nv_module(name)
	local mod_tbl = {}
	return mod_tbl, {__index = mod_tbl}
end

-- basic libraries (other libraries are loaded on demand) 
require("lgob.gtk")
require("lgob.gdk")	
require("lgob.cairo")
require("lfann")
require("lcl")

_ = lcl.gettext
lcl.bindtextdomain("neuralview", "po")

NVVersion = "0.3.0"
NVIcon = gdk.Pixbuf.new_from_file("logo.png")

-- ** Main **

local MainController = require("core.MainController")

local MainApp = {}
local MainAppMT = {__index = MainApp}

---
-- Constructor.
function MainApp.new()
	local self = {}
	setmetatable(self, MainAppMT)
	
	self.controller = MainController.new()
	
	return self
end

---
-- Runs the application.
function MainApp:run()
	self.controller:run()
end

-- Main

local app = MainApp.new()
app:run()
